using System;

using YamlDotNet.Core;
using YamlDotNet.Serialization;

namespace Syntriax.Engine.Core.Serialization;

public abstract class EngineTypeYamlSerializerBase<T> : IEngineTypeYamlSerializer
{
    protected const string SERIALIZED_SCALAR_NAME = "Properties";

    public EntityRegistry EntityRegistry { get; set; } = null!;

    public bool Accepts(Type type) => typeof(T).IsAssignableFrom(type);

    public abstract T? Read(IParser parser, Type type, ObjectDeserializer rootDeserializer);
    public object? ReadYaml(IParser parser, Type type, ObjectDeserializer rootDeserializer)
    {
        T? result = Read(parser, type, rootDeserializer);

        if (result is IEntity entity)
            EntityRegistry.Add(entity);

        return result;
    }

    public abstract void WriteYaml(IEmitter emitter, object? value, Type type, ObjectSerializer serializer);
}
